# Tematika
- Uvod u VI
    - Bodovanje
    - Primena vestacke inteligencije
- Uvod u Python
    - Podsecanje na osnovne Python-a
    - OOP koncepti u Python-u

## Uvod u VI

### Primena vestacke inteligencije

####
- [Coloring graph using SAT](https://www.youtube.com/watch?v=0gt503wK7AI&t=194s)
- [Resavanje igre SUDOKU koristeci SAT](https://github.com/lakshayg/sudoku)
- [DeepMind Parkour](https://www.youtube.com/watch?v=g59nSURxYgk)
- [AI igra Marija](https://www.youtube.com/watch?v=A97HL3_fxyo)
- [AlphaZero masters chess](https://www.youtube.com/watch?v=0g9SlVdv1PY)
- [AI learns to play snake](https://www.youtube.com/watch?v=3bhP7zulFfY)
- [AI learns to drive in GTA V](https://www.youtube.com/watch?v=edWI4ZnWUGg)
- [AI learns to play 2048](https://www.youtube.com/watch?v=JQut67u8LIg)
- [Dijkstra vs Astar vs Concurent Dijstra](https://www.youtube.com/watch?v=cSxnOm5aceA)
- [Astar vs Dikstra](https://www.youtube.com/watch?v=g024lzsknDo)
- [Pathfinding algorithms in Java](https://www.youtube.com/watch?v=CLbqqb53DLA&app=desktop)
- [Ant optimization](https://www.youtube.com/watch?v=eVKAIufSrHs)
- [Particle swarm optimization](https://www.youtube.com/watch?v=gkGa6WZpcQg)
- [cleverbot](http://www.cleverbot.com/)
- [Genetic algorithm learns to walk](https://www.youtube.com/watch?v=uwz8JzrEwWY)
- [Genetic algoritm grows a car](https://www.youtube.com/watch?v=FKbarpAlBkw)
- [Genetic algorithm pathfinding](https://www.youtube.com/watch?v=BKF7pGw8qbY&app=desktop)

### Pretraga
- Ilustracije razlike u brzini `A*` u odnosu na dijkstrin algoritam
- 100+ puta brze od `A*`: [JumpPointSearch+](https://www.gdcvault.com/play/1022094/JPS-Over-100x-Faster-than)
- Pomenuti problem `pathfinding`-a u video igrama i kako se realizuje

### Genetski algoritmi
- [Primer](https://gist.github.com/bellbind/741853) u Python-u koji sam pronasao
- Nemanja: imao sam prilike da se igram sa ovim, mogu ja pripremiti ovaj deo

### Minimaks
- [x] Spremiti primer (Aleksandrov primer sa AISP-a)
- Na vezbama pomenuti da ce na predavanjima raditi dublje o igrama nulte sume

### Masinsko ucenje
- Klasifikator spam mejlova (nesto komplikovaniji primer za studente)
- Mozda implementirati neki primer iz skipte (tema za kasnije razmisljanje)?

#### Skupovi podataka
- [spam dataset](http://csmining.org/index.php/spam-email-datasets-.html)
- [iris](https://archive.ics.uci.edu/ml/datasets/iris)

## Uvod u Python
Studenti su na kursu PPJ slusali 3 nedelje o Python-u, tamo su radili citanje i pisanje
u datoteku, grananje, petlje, funkcije i regularne izraze. Sintaksa Python-a im je solidno
poznata. Ipak ne mozemo imati pretpostavku da znaju Python jer PPJ nije uslovan kurs za VI.

To ipak ne znaci da moramo drzati kompletan uvod u Python jer na kursu *Programske Paradigme* (PP na dalje)
se u okviru skript paradigme radi Python i to sasvim ozbiljno (krece se vec prve nedelje sa tim).

Dakle, nas fokus treba biti na objektnim konceptima u Python-u, klasama, objektima, nasledjivanju,
modularnosti i slicno, sto se uopste ne radi na fakultetu kroz Python pa moze biti zgodno studentima.

Sem toga, kasnije bi trebali da masinsko ucenje implementiramo u Python-u koristeci [numpy](http://www.numpy.org/).
